﻿using System.Collections;
using System.Collections.Generic;
using Pippin;
using Pippin.Player;
using UnityEngine;

public class PortRoom : MonoBehaviour
{
    //public float TimePassRoom = 3f;
    public DirecaoPlayer direcao;
    [HideInInspector]
    public bool Aberta;
    [HideInInspector]
    public MoveRoom room;
    PlayerController player;
    [HideInInspector]
    public bool PlayerSaiuDestaPorta;
    bool realizandoMudanca;

    void Start()
    {
        Aberta = true;
    }

    void OnTriggerEnter2D(Collider2D collision)
    {
        VerificarPortaAberta();
        if (Aberta && !realizandoMudanca && !PlayerSaiuDestaPorta && collision.CompareTag("Player"))
        {
            player = collision.GetComponent<PlayerController>();
            realizandoMudanca = true;
            PlayerController.Instance.esperarPassagemSala = true;
            FadeImage.Instance._fade(2, true, EsperarPassarPorta);
        }
    }

    void OnTriggerExit2D(Collider2D collision)
    {
        if (PlayerSaiuDestaPorta && collision.CompareTag("Player"))
        {
            PlayerSaiuDestaPorta = false;
        }
    }

    void VerificarPortaAberta()
    {
        switch (direcao)
        {
            case DirecaoPlayer.UP:

                if(room.SalasVizinhas[0] == null)
                {
                    Aberta = false;
                }

                break;
            case DirecaoPlayer.RIGHT:

                if (room.SalasVizinhas[1] == null)
                {
                    Aberta = false;
                }

                break;
            case DirecaoPlayer.DOWN:

                if (room.SalasVizinhas[2] == null)
                {
                    Aberta = false;
                }

                break;
            case DirecaoPlayer.LEFT:

                if (room.SalasVizinhas[3] == null)
                {
                    Aberta = false;
                }

                break;
        }
    }

    void EsperarPassarPorta()
    {
        Transform posicaoPlayer = null;
        Transform novaSala = null;
        switch(direcao)
        {
            case DirecaoPlayer.UP:
                posicaoPlayer = room.SalasVizinhas[0].GetComponent<MoveRoom>().pontosSpawnplayerRoom[2].transform;
                novaSala = room.SalasVizinhas[0].transform;
                break;
            case DirecaoPlayer.RIGHT:
                posicaoPlayer = room.SalasVizinhas[1].GetComponent<MoveRoom>().pontosSpawnplayerRoom[3].transform;
                novaSala = room.SalasVizinhas[1].transform;
                break;
            case DirecaoPlayer.DOWN:
                posicaoPlayer = room.SalasVizinhas[2].GetComponent<MoveRoom>().pontosSpawnplayerRoom[0].transform;
                novaSala = room.SalasVizinhas[2].transform;
                break;
            case DirecaoPlayer.LEFT:
                posicaoPlayer = room.SalasVizinhas[3].GetComponent<MoveRoom>().pontosSpawnplayerRoom[1].transform;
                novaSala = room.SalasVizinhas[3].transform;
                break;
        }

        player.transform.position = posicaoPlayer.position;
        posicaoPlayer.GetComponent<PortRoom>().PlayerSaiuDestaPorta = true;
        realizandoMudanca = false;

        Vector3 ps = novaSala.position;
        ps.z = Camera.main.transform.position.z;
        Camera.main.transform.position = ps;

        PlayerController.Instance.esperarPassagemSala = false;

        FadeImage.Instance._fade(2, false);
    }

}
